'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateClassName;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _compressClassName = require('./compressClassName');

var _compressClassName2 = _interopRequireDefault(_compressClassName);

var _splitSelector3 = require('./utils/splitSelector');

var _splitSelector4 = _interopRequireDefault(_splitSelector3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var invalidChars = /[^_a-z0-9-]/ig;

function generateClassName(id, options) {
  var result = '';

  if (options.prefix) {
    result += options.prefix.replace(invalidChars, '_') + '-';
  } else if (options.prefixes) {
    result += options.prefixes.map(function (p) {
      return p.replace(invalidChars, '_');
    }).join('-') + '-';
  }

  result += id;

  if (options.compressClassNames) {
    var _splitSelector = (0, _splitSelector4.default)(result);

    var _splitSelector2 = (0, _slicedToArray3.default)(_splitSelector, 2);

    var className = _splitSelector2[0];
    var selector = _splitSelector2[1];

    return (0, _compressClassName2.default)(className, options) + selector;
  }

  return result;
}
