'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasOwnProperty = Object.prototype.hasOwnProperty;

function remove(filePath) {
  if (_fs2.default.existsSync(filePath)) {
    _fs2.default.unlinkSync(filePath);
  }
}

function load(filePath) {
  if (!_fs2.default.existsSync(filePath)) {
    _mkdirp2.default.sync(_path2.default.dirname(filePath));
    store({}, filePath);
    return {};
  }

  var data = _fs2.default.readFileSync(filePath, { encoding: 'utf8' });

  return JSON.parse(data);
}

function store(data, filePath) {
  _fs2.default.writeFileSync(filePath, JSON.stringify(data));
}

var DiskCache = (function () {
  function DiskCache(name, options) {
    (0, _classCallCheck3.default)(this, DiskCache);

    this.filePath = _path2.default.resolve(_path2.default.join(options.cacheDir, name + '.json'));

    this.fetch.bind(this);
    this.clear.bind(this);
  }

  (0, _createClass3.default)(DiskCache, [{
    key: 'fetch',
    value: function fetch(key, miss) {
      var cache = load(this.filePath);

      if (hasOwnProperty.call(cache, key)) {
        return cache[key];
      }

      cache[key] = miss((0, _keys2.default)(cache));

      store(cache, this.filePath);

      return cache[key];
    }
  }, {
    key: 'clear',
    value: function clear() {
      remove(this.filePath);
    }
  }]);
  return DiskCache;
})();

exports.default = DiskCache;
